// Wuerfelspiel.java

import ch.aplu.util.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.Color;


class Wuerfelspiel
{
  private GPanel p;
  private int w1, w2, w3;
  private int einsatz;
  private int tip;
  private int punkte = 20;
  private int i = 1;

  private JLabel labelPunkte = new JLabel("Punktestand: ");
  private JTextField textPunkte = new JTextField(6);
  private JLabel labelEinsatz = new JLabel("Einsatz: ");
  private JTextField textEinsatz = new JTextField(5);
  private String sEinsatz = "";
  private JLabel labelTip = new JLabel("Tip:");
  private JTextField textTip = new JTextField(5);
  private String sTip = "";
  private JButton wButton = new JButton("wuerfeln");
  private JTextField textAntwort = new JTextField(40);
  private String antwort = "";
  private JMenuItem helpItem, newItem, exitItem;

  private Wuerfel wuerfel1;
  private Wuerfel wuerfel2;
  private Wuerfel wuerfel3;


  Wuerfelspiel()
  {
    createGUI();

    registerMenuItemListeners();
    textPunkte.setText("  " + punkte);

    wButton.addActionListener(new ActionListener()
    {
       public void actionPerformed(ActionEvent evt)
       {
         if (punkte > 0)
           start();
       }
     });

    wuerfel1 = new Wuerfel(20, 65, 24, w1, p);
    wuerfel2 = new Wuerfel(50, 65, 24, w2, p);
    wuerfel3 = new Wuerfel(80, 65, 24, w3, p);


  }

  private void start()
  {
    sEinsatz = textEinsatz.getText().trim();
    sTip = textTip.getText().trim();
    if (sEinsatz.equals("") || sTip.equals(""))
    {
      antwort = "Bitte Einsatz und Tipp eingeben!";
      textAntwort.setText(antwort);
      return;
    }

    einsatz = Integer.parseInt(sEinsatz);
    tip = Integer.parseInt(sTip);


    w1 = (int)(Math.random() * 6 + 1);
    w2 = (int)(Math.random() * 6 + 1);
    w3 = (int)(Math.random() * 6 + 1);
    wuerfel1.wuerfle(w1);
    wuerfel2.wuerfle(w2);
    wuerfel3.wuerfle(w3);

    if((w1 == tip) && (w2 == tip) && (w3 == tip))
    {
      punkte = punkte + 3 * einsatz;
      antwort = "Runde " + i + ", gut getippt, 3 mal Einsatz gewonnen!";
    }
    else if ((w1 == tip && w2 == tip) || (w2 == tip && w3 == tip) || (w1 == tip && w3 == tip))
    {
      punkte = punkte + 2 * einsatz;
      antwort = "Runde " + i + ", gut getippt, 2 mal Einsatz gewonnen!";
    }
    else if(w1 == tip || w2 == tip || w3 == tip)
    {
      punkte = punkte + einsatz;
      antwort = "Runde " + i + ", gut getippt, 1 mal Einsatz gewonnen!";
    }
    else
      {
        punkte = punkte - einsatz;
        antwort = "Runde " + i + ", falsch getippt!";
        if (punkte <= 0)
          antwort = "Runde " + i + ", Sie haben verloren!";
      }

    textPunkte.setText("  " + punkte);
    i++;
    textAntwort.setText(antwort);

    p.validate();

  }


  private void createGUI()
  {

    helpItem = new JMenuItem("Spielregeln anzeigen");
    newItem = new JMenuItem("       Neues Spiel");
    exitItem = new JMenuItem("Spiel beenden");

    JMenuBar menuBar = new JMenuBar();
    menuBar.add(helpItem);
    menuBar.add(newItem);
    menuBar.add(exitItem);

    p =  new GPanel("Wrfelspiel", menuBar, 0, 100, 0, 100);

    p.add(labelPunkte);
    p.add(textPunkte);
    p.add(labelEinsatz);
    p.add(textEinsatz);
    p.add(labelTip);
    p.add(textTip);
    p.add(wButton);
    p.add(textAntwort);
    p.validate();

  }

  private void registerMenuItemListeners()
  {
    helpItem.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        p.color(Color.black);
        p.text(5, 40,"Spielregeln: ");
        p.text(5, 36, "Zu Beginn erhalten Sie 20 Punkte, das Ziel ist diese Punktezahl zu vergrssern.");
        p.text(5, 32, "Sie geben den Einsatz ein und die Wrfelzahl, auf die sie tippen. Mit Klick auf");
        p.text(5, 28, "wrfeln werden drei Wrfel geworfen. Kommt die getipte Zahl einmal vor, wird der");
        p.text(5, 24, "Einsatz zu Ihrem Punktestand addiert, kommt sie zweimal vor,das Doppelte,kommt ");
        p.text(5, 20, "sie dreimal vor das Dreifache. Anderfalls wird der Einsatz abgezogen.");
        p.text(5, 16, "Beim Punktestand 0 haben Sie verloren.");
        p.text(5, 12, "Sie knnen mit Klick auf Neues Spiel noch einmal versuchen...");
        p.validate();
      }

    });

    newItem.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        punkte = 20;
        i = 1;
        textPunkte.setText("  " + punkte);
        textEinsatz.setText(" ");
        textTip.setText(" ");
        textAntwort.setText(" ");
        wuerfel1.loesche();
        wuerfel2.loesche();
        wuerfel3.loesche();
        p.validate();
      }

    });

    exitItem.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        System.exit(0);
      }

    });
  }

  public static void main(String[] args)
  {
     new Wuerfelspiel();
  }
}

// -----------------Wuerfel.java------------------------------------------

class Wuerfel
{
  private GPanel p;
  private Punkt punkt = new Punkt();
  private double x;      //Mitte des Wrfels
  private double y;
  private double seite ; //Wrfelseite
  private double d ;     //Abstand zwischen Punkten
  private int zahl;      //Anzahl Wrfelpunkte

  private boolean [] a0 = {false, false, false, false, true, false, false, false, false};
  private boolean [] a1 = {false, false, true, false, false, false, true, false, false};
  private boolean [] a2 = {false, false, true, false, true, false, true, false, false};
  private boolean [] a3 = {true, false, true, false, false, false, true, false, true};
  private boolean [] a4 = {true, false, true, false, true, false, true, false, true};
  private boolean [] a5 = {true, false, true, true, false, true, true, false, true};

  private boolean [][] augen = {a0, a1, a2, a3, a4, a5};

  Wuerfel(double xPos, double yPos, double wuerfelSeite, int vZahl, GPanel apanel)
  {
     p = apanel;
     x = xPos;
     y = yPos;
     seite = wuerfelSeite;
     d = seite / 3;
     zahl = vZahl;
  }

  private class Punkt
  {
    void draw(double x, double y)
    {
       p.pos(x, y);
       p.color(Color.white);
       p.fillCircle(2);;
    }
  }

  public void wuerfle(int vZahl)
  {
    w();
    zahl = vZahl - 1;
    //int value = (int)(Math.random() * 6);
    if (augen[zahl][0])
      punkt.draw(x -d , y - d);
    if (augen[zahl][1])
      punkt.draw(x, y - d);
    if (augen[zahl][2])
      punkt.draw(x + d, y - d);
    if (augen[zahl][3])
     punkt.draw(x -d, y);
    if (augen[zahl][4])
      punkt.draw(x, y);
    if (augen[zahl][5])
      punkt.draw(x + d, y);
    if (augen[zahl][6])
      punkt.draw(x - d, y + d);
    if (augen[zahl][7])
      punkt.draw(x, y + d);
    if (augen[zahl][8])
      punkt.draw(x + d, y + d);
  }

  private void w()
  {
    p.color(Color.red);
    p.move(x, y);
    p.fillRectangle(seite, seite);
  }

  public void loesche()
  {
    p.color(Color.white);
    p.move(x, y);
    p.fillRectangle(seite, seite);
  }
}
